CBV/CBV/urls.py
from django.contrib import admin
from django.urls import path, include

urlpatterns = [
    path('admin/', admin.site.urls),
    path('', include('first.urls', namespace='first')),
    path('accounts/', include('accounts.urls', namespace='accounts')),
]

CBV/accounts/urls.py
from django.urls import path
from django.contrib.auth import views as auth_view
from . import views

app_name = 'accounts'

urlpatterns = [
    path('login/', views.UserLogin.as_view(), name='login'),
    # path('login/', auth_view.LoginView.as_view(template_name='accounts/login.html'), name='login'),
    path('logout/', auth_view.LogoutView.as_view(next_page='first:home'), name='logout'),
    path('reset/', views.UserPassReset.as_view(), name='reset_pass'),
    path('reset/done/', views.PasswordResetDone.as_view(), name='password_reset_done'),
    path('confirm/<uidb64>/<token>/', views.PasswordResetConfirm.as_view(), name='password_reset_confirm'),
    path('confirm/done', views.PasswordResetComplete.as_view(), name='password_reset_complete'),
]

CBV/first/urls.py
from django.urls import path
from . import views

app_name = 'first'
urlpatterns = [
    path('', views.Home.as_view(), name='home'),
    path('create/', views.TodoCreat.as_view(), name='create'),
    path('Delete/<int:pk>', views.TodoDelete.as_view(), name='delete'),
    path('update/<int:pk>', views.UpdateTodo.as_view(), name='update'),
    path('<slug:myslug>/', views.DetailTodo.as_view(), name='Detail_Todo'),
    path('<int:year>/<str:month>', views.MonthTodo.as_view(), name='month_todo')

]

CBV/accounts/models.py
from django.db import models

# Create your models here.

CBV/first/models.py
from django.db import models


class Todo(models.Model):
    title = models.CharField(max_length=100)
    created = models.DateTimeField(auto_now_add=True)
    slug = models.SlugField(blank=True, null=True)


class Comment(models.Model):
    todo = models.ForeignKey(Todo, models.CASCADE, related_name='tcomment')
    name = models.CharField(max_length=200)
    body = models.TextField()

    def __str__(self):
        return self.name

CBV/first/forms.py
from django import forms

from first.models import Comment


class TodoCreatedForm(forms.Form):
    title = forms.CharField(max_length=100)


class TodoCommentForm(forms.ModelForm):
    class Meta:
        model = Comment
        fields = ('name', 'body')

CBV/accounts/views.py
from django.shortcuts import render
from django.contrib.auth import views as auth_view
from django.urls import reverse_lazy


class UserLogin(auth_view.LoginView):
    template_name = 'accounts/login.html'


class UserPassReset(auth_view.PasswordResetView):
    template_name = 'accounts/password_reset_form.html'
    success_url = reverse_lazy('accounts:password_reset_done')
    email_template_name = 'accounts/password_reset_email.html'


class PasswordResetDone(auth_view.PasswordResetDoneView):
    template_name = 'accounts/reset_done.html'


class PasswordResetConfirm(auth_view.PasswordResetConfirmView):
    template_name = 'accounts/password_reset_confirm.html'
    success_url = reverse_lazy('accounts:password_reset_complete')


class PasswordResetComplete(auth_view.PasswordResetCompleteView):
    template_name = 'accounts/password_reset_complete.html'

CBV/first/views.py
from django.contrib import messages
from django.shortcuts import render
from django.urls import reverse_lazy, reverse
from django.utils.text import slugify
from django.views import View
from django.views.generic.base import TemplateView
from first.models import Todo, Comment
from django.views.generic import ListView, DetailView, FormView, CreateView, DeleteView, UpdateView
# also we can do those :
# from django.views.generic.list import ListView
# from django.views.generic.detail import DetailView
# from django.views.generic.edit import FormView
# from django.views.generic.edit import CreateView
from .forms import TodoCreatedForm, TodoCommentForm
from django.views.generic.dates import MonthArchiveView
from django.contrib.auth.mixins import LoginRequiredMixin
from django.views.generic.edit import FormMixin


class UpdateTodo(UpdateView):
    model = Todo
    fields = ('title',)
    template_name = 'first/update_todo.html'
    success_url = reverse_lazy('first:home')


class TodoDelete(DeleteView):
    model = Todo
    template_name = 'first/todo_delete.html'
    success_url = reverse_lazy('first:home')


class TodoCreat(CreateView):
    model = Todo
    fields = ('title',)
    template_name = 'first/todo_create.html'
    success_url = reverse_lazy('first:home')

    def form_valid(self, form):
        todo = form.save(commit=False)
        todo.slug = slugify(form.cleaned_data['title'])
        todo.save()
        return super().form_valid(form)


# class TodoCreat(FormView):
#     form_class = TodoCreatedForm
#     template_name = 'first/todo_create.html'
#     success_url = reverse_lazy('first:home')
#
#     def form_valid(self, form):
#         self.create_todo(form.cleaned_data)
#         return super().form_valid(form)
#
#     def create_todo(self, data):
#         todo = Todo(title=data['title'], slug=slugify(data['title']))
#         todo.save()
#         messages.success(self.request, 'your todo added', 'success')
#

# todo : use mixins for DetailView :
class DetailTodo(LoginRequiredMixin, FormMixin, DetailView):  # first/todo_detail.html
    model = Todo
    form_class = TodoCommentForm
    slug_field = 'slug'
    slug_url_kwarg = 'myslug'

    def get_success_url(self):
        return reverse('first:Detail_Todo', kwargs={'myslug': self.object.slug})

    def post(self, request, *args, **kwargs):
        self.object = self.get_object()
        form = self.get_form()
        if form.is_valid():
            comment = Comment(todo=self.object, name=form.cleaned_data['name'], body=form.cleaned_data['body'])
            comment.save()
            return super().form_valid(form)


# class DetailTodo(DetailView):  # first/todo_detail.html
#     slug_field = 'slug'
#     slug_url_kwarg = 'myslug'
#
#     def get_queryset(self, **kwargs):
#         if self.request.user.is_authenticated:
#             return Todo.objects.filter(slug=self.kwargs['myslug'])
#         else:
#             return Todo.objects.none()


class Home(ListView):
    template_name = 'first/home.html'
    queryset = Todo.objects.all()
    context_object_name = 'todos'
    ordering = ['-created']

    def get_queryset(self):
        return Todo.objects.all()


# class Home(TemplateView):
#     template_name = 'first/home.html'
#
#     def get_context_data(self, **kwargs):
#         context = super().get_context_data(**kwargs)
#         context['todos'] = Todo.objects.all()
#         return context

# use View for send data  :
# class Home(View):
#     def get(self, request, *args, **kwargs):
#         return render(request, 'first/home.html', {'name': 'ramin'})


# def home(request):
#     return render(request, 'first/home.html')

class MonthTodo(MonthArchiveView):
    model = Todo
    date_field = 'created'
    # month_format = '%m    '
    template_name = 'first/todo_month.html'

CBV/accounts/templates/accounts/login.html
{% extends 'base.html' %}
{% block content %}
    <form action="" method="post">
        {% csrf_token %}
        {{ form }}
        <input type="submit" value="login">
    </form>
{% endblock %}

CBV/accounts/templates/accounts/password_reset_complete.html
{% extends 'base.html' %}
{% block content %}
    <p>your password changed successfully , now you can login with new password :)</p>
{% endblock %}

CBV/accounts/templates/accounts/password_reset_confirm.html
{% extends 'base.html' %}
{% block content %}
    {% if validlink %}
        <form action="" method="post">
            {% csrf_token %}
            {{ form }}
            <input type="submit" value="change">
        </form>
    {% else %}
        <p>This link is not valid ,please try again !</p>
    {% endif %}
{% endblock %}

CBV/accounts/templates/accounts/password_reset_email.html
someone asked for password reset for email {{ email }}.
follow the link below:
{{ protocol}}://{{ domain }}{% url 'accounts:password_reset_confirm' uidb64=uid token=token %}

CBV/accounts/templates/accounts/password_reset_form.html
{% extends 'base.html' %}
{% block content %}
    <form action="" method="post">
        {% csrf_token %}
        <p>if you lost your pass here and we'll send you an email :</p>
        {{ form }}
        <input type="submit" value="send">
    </form>
{% endblock %}

CBV/accounts/templates/accounts/reset_done.html
{% extends 'base.html' %}
{% block content %}
    <p>please check your email and reset your password </p>
{% endblock %}

CBV/first/templates/first/home.html
{% extends 'base.html' %}
{% block content %}
    <h3>Home {{ name }}</h3>
    <h3>{% for todo in todos %}
        <a href="{% url 'first:Detail_Todo' todo.slug %}">
            {{ todo.title }}
        </a>
        <a href="{% url 'first:delete' todo.id %}" class="btn btn-danger">Delete</a>
        <a href="{% url 'first:update' todo.id %}" class="btn btn-warning">Update</a><br><br>
    {% endfor %}</h3>
{% endblock %}

CBV/first/templates/first/todo_create.html
{% extends 'base.html' %}
{% block content %}
    <form action="" method="post">
        {% csrf_token %}
        {{ form.as_p }}
        <input type="submit" value="send" class="btn btn-primary">
    </form>

{% endblock %}

CBV/first/templates/first/todo_delete.html
{% extends 'base.html' %}
{% block content %}
    <form action="" method="post">
    {% csrf_token %}
    <p>do you really wanna delete "{{ object.title }}" ?</p>
        <input type="submit" value="Delete">
    </form>
{% endblock %}

CBV/first/templates/first/todo_detail.html
{% extends 'base.html' %}
{% block content %}
    <p>{{ object.title }}</p>
    <small>{{ object.created }}</small><br><br>
    <hr>
    <form action="" method="post">
    {% csrf_token %}
    {{ form.as_p }}
        <input type="submit" value="send" class="btn btn-primary">
    </form><br><br>
    <hr>
    {% for cmt in object.tcomment.all %}
        {{ cmt.name }}<br>
        <small>{{ cmt.body }}</small>
        <br>
        <hr>
    {% endfor %}


{% endblock %}

CBV/first/templates/first/todo_month.html
{% extends 'base.html' %}
{% block content %}
    {% for todo in object_list  %}
        {{ todo.title }}<br>

    {% endfor %}

{% endblock %}

CBV/first/templates/first/update_todo.html
{% extends 'base.html' %}
{% block content %}
    <form action="" method="post">
        {% csrf_token %}
        {{ form.as_p }}
        <input type="submit" class="btn btn-primary" value="send">
    </form>
{% endblock %}

CBV/templates/base.html
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <title>weblog</title>
    <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.4.1/css/bootstrap.min.css"
          integrity="sha384-Vkoo8x4CGsO3+Hhxv8T/Q5PaXtkKtu6ug5TOeNV6gBiFeWPGFN9MuhOf23Q9Ifjh" crossorigin="anonymous">
    {% block custom_tag %}{% endblock %}
</head>
<body>
{% include 'inc/navbar.html' %}
<div class="jumbotron">
    {% include 'inc/messages.html' %}
    {% block content %}
    {% endblock %}
</div>

</body>
</html>